Redmine - Defect #3462

CVS: Repository path encoding of non UTF-8 characters
2009-06-08 16:24 - Rodrigo Rosenfeld Rosas

Status: Closed Start date: 2009-06-08
Priority: Low Due date:

Assignee: Toshi MARUYAMA % Done: 0%
Category: SCM Estimated time: 0.00 hour
Target version: 1.2.0

Resolution: Fixed Affected version:

Description

We have some "ISO-8859-1" encoded filenames in our CVS repository. Repository.find(20).fetch_updates yields this error:

ActiveRecord::Statementinvalid (PGError: ERROR: invalid byte sequence for encoding "UTF8": 0xf3706961

HINT: This error can also happen if the byte sequence does not match the encoding expected by the server, which is controlled by
"client_encoding".

: SELECT "changes".” FROM "changes" INNER JOIN changesets ON changes.changeset_id = changesets.id WHERE
("changes"."revision" = E'1.2" AND "changes"."path" = E'/xxxxx/AlterarSenha (c<F3>pia).png') AND (("changesets".repository_id =
20)) LIMIT 1):

The attached patch solved the problem for us.

Above is the relevant stack:
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/connection_adapters/abstract_adapter.rb:188:in “log'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/connection_adapters/postgresql_adapter.rb:503:in “execute'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/connection_adapters/postgresql_adapter.rb:1000:in
“select_raw'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/connection_adapters/postgresql_adapter.rb:987:in “select'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/connection_adapters/abstract/database_statements.rb:7:in
“select_all_without_query_cache'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/connection_adapters/abstract/query_cache.rb:60:in “select_all'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/connection_adapters/abstract/query_cache.rb:81:in “cache_sql'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/connection_adapters/abstract/query_cache.rb:60:in “select_all'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/base.rb:635:in *find_by_sql’
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/base.rb:1490:in “find_every'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/base.rb:1452:in “find_initial’
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/base.rb:587:in “find'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/base.rb:1812:in “find_by_path_and_revision'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/associations/association_collection.rb:370:in “send’
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/associations/association_collection.rb:370:in “method_missing'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/base.rb:2003:in “with_scope’
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/associations/association_proxy.rb:202:in “send’
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/associations/association_proxy.rb:202:in “with_scope'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/associations/association_collection.rb:366:in “method_missing'
/app/models/repository/cvs.rb:107:in “fetch_changesets'

/lib/redmine/scm/adapters/cvs_adapter.rb:192:in “revisions'

/lib/redmine/scm/adapters/cvs_adapter.rb:126:in “each_line'

/lib/redmine/scm/adapters/cvs_adapter.rb:126:in “revisions'

/lib/redmine/scm/adapters/abstract_adapter.rb:181:in “call’

/lib/redmine/scm/adapters/abstract_adapter.rb:181:in “shellout’

/lib/redmine/scm/adapters/abstract_adapter.rb:179:in “popen’

/llib/redmine/scm/adapters/abstract_adapter.rb:179:in “shellout’

/llib/redmine/scm/adapters/abstract_adapter.rb:165:in “shellout’

/lib/redmine/scm/adapters/cvs_adapter.rb:114:in “revisions'

/app/models/repository/cvs.rb:104:in “fetch_changesets'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/connection_adapters/postgresql_adapter.rb:550:in “transaction’
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/transactions.rb:129:in “transaction'
/opt/redmine/.gem/ruby/1.8/gems/activerecord-2.2.2/lib/active_record/transactions.rb:138:in “transaction'
/app/models/repository/cvs.rb:102:in “fetch_changesets'

Related issues:
Related to Redmine - Defect #2664: Mercurial: Repository path encoding of non... Closed

2009-02-04

Associated revisions

Revision 5461 - 2011-04-15 09:15 - Toshi MARUYAMA

scm: cvs: set path encoding instance value (#3462).

Revision 5462 - 2011-04-15 09:16 - Toshi MARUYAMA

scm: cvs: convert encoding of command line arguments (#3462).

Revision 5463 - 2011-04-15 09:16 - Toshi MARUYAMA

scm: cvs: convert encoding paths in revisions() of adapter (#3462).

Revision 5464 - 2011-04-15 09:17 - Toshi MARUYAMA

scm: cvs: convert encoding paths in entries() of adapter (#3462).

Revision 5465 - 2011-04-15 09:18 - Toshi MARUYAMA

scm: cvs: add path encoding select box at setting (#3462).

Revision 5520 - 2011-04-23 05:35 - Toshi MARUYAMA
scm: use i18n string at path encoding setting (#2274, #2664, #3462, #5251).

Revision 5521 - 2011-04-23 05:35 - Toshi MARUYAMA
scm: add Japanese translation "field_scm_path_encoding" (#2274, #2664, #3462, #5251).

Revision 5522 - 2011-04-23 05:36 - Toshi MARUYAMA
scm: update locales for path encoding setting (#2274, #2664, #3462, #5251).

Revision 5523 - 2011-04-23 05:36 - Toshi MARUYAMA
scm: use i18n string at path encoding setting note (#2274, #2664, #3462, #5251).

Revision 5524 - 2011-04-23 05:37 - Toshi MARUYAMA
scm: add Japanese string at path encoding setting note (#2274, #2664, #3462, #5251).

Revision 5525 - 2011-04-23 05:37 - Toshi MARUYAMA
scm: update locales for path encoding setting note (#2274, #2664, #3462, #5251).

Revision 5630 - 2011-05-04 07:02 - Toshi MARUYAMA
scm: cvs: fix loss non ASCII paths if path_encoding is " (#3462).

Revision 5863 - 2011-05-21 04:16 - Toshi MARUYAMA
scm: add "path_encoding" method in abstract adapter (#2274, #3462, #2664, #5251).

Revision 5866 - 2011-05-21 04:18 - Toshi MARUYAMA

scm: cvs: override "path_encoding" method in adapter (#3462).

Revision 5867 - 2011-05-21 04:19 - Toshi MARUYAMA
scm: cvs: add unit adapter test of default path_encoding is UTF-8 (#3462).

History

#1 - 2011-02-08 05:53 - Toshi MARUYAMA
- Assignee set to Toshi MARUYAMA
- Priority changed from High to Normal

#2 - 2011-02-21 01:46 - Toshi MARUYAMA
- Assignee deleted (Toshi MARUYAMA)

- Priority changed from Normal to Low
Ruby 1.9 compatibility is very serious.

#3 - 2011-04-15 09:00 - Toshi MARUYAMA
- Assignee set to Toshi MARUYAMA

#4 - 2011-04-15 09:01 - Toshi MARUYAMA

- Subject changed from CVS path encoding problems to CVS: Repository path encoding of non UTF-8 characters

#5 - 2011-04-15 09:21 - Toshi MARUYAMA

- Target version set to 1.2.0

#6 - 2011-04-15 09:24 - Toshi MARUYAMA
- Status changed from New to Closed

- Resolution set to Fixed

| finished implementing in r5465.
| can not prepare test repository for same reason with filesystem repository #2274.

If tar ball has Latin-1 path encoding files, | can't extract it on my Japanese Windows.

There are same limitations with git #5251.

Files
cvs-path-encoding.patch 471 Bytes 2009-06-08 Rodrigo Rosenfeld Rosas
https://www.redmine.org/projects/redmine/repository/svn/revisions/5465
https://www.redmine.org/issues/2274
https://www.redmine.org/issues/5251
http://www.tcpdf.org

